package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryTypeCustomerCsdcDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryTypeCustomerCsdcDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryTypeCustomerCsdcDao;
import com.friday.custody.entity.DataDictionaryTypeCustomerCsdcEntity;
import com.friday.custody.service.basicService.DataDictionaryTypeCustomerCsdcService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryTypeCustomerCsdcService")
public class DataDictionaryTypeCustomerCsdcServiceImpl extends ServiceImpl<DataDictionaryTypeCustomerCsdcDao, DataDictionaryTypeCustomerCsdcEntity>
        implements DataDictionaryTypeCustomerCsdcService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryTypeCustomerCsdcEntity> page = this.page(
                new Query<DataDictionaryTypeCustomerCsdcEntity>().getPage(params),
                new QueryWrapper<DataDictionaryTypeCustomerCsdcEntity>()
        );

        return new PageUtils(page);
    }



    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Autowired
    private DataDictionaryTypeCustomerCsdcDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryTypeCustomerCsdcEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryTypeCustomerCsdcDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryTypeCustomerCsdcDetailsEntity::getOriginValue, DataDictionaryTypeCustomerCsdcDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryTypeCustomerCsdcEntity::getId, DataDictionaryTypeCustomerCsdcEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryTypeCustomerCsdcDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryTypeCustomerCsdcEntity 查询失败！");
        }
        return result;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryTypeCustomerCsdcEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryTypeCustomerCsdcEntity::getKeyStr
                            ,DataDictionaryTypeCustomerCsdcEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}